<?php
/*
OekakiBBS parse code by Marcello (http://www.cellosoft.com). Modified by RanmaGuy. Used with permission. This file is not to be used with any other script other than OekakiPoteto.

Wacintaki Poteto modifications Copyright 2004-2005 Marc "Waccoon" Leveille, http://www.NineChime.com/Wacintosh.htm
Version 1.2.0 - Last modified 3/18/2005
*/


function quiet_exit($exit_err) {
	global $dbconn;
	@mysql_close ($dbconn);

	header ('Content-type: text/plain');
	exit ($exit_err);
}


// NOTE:  Cookies don't [aren't supposed to] work with POST
// Load bootstrap, quiet mode
$OekakiU    = $_GET['usr'];
$OekakiPass = $_GET['vcode'];
$quiet_mode = 1;
define ('BOOT', 1);
require ('boot.php');

// Input
$mode      = $_GET['mode'];
$edittimes = (int) $_GET['edittimes'];
$edit      = (int) $_GET['edit'];


if (empty ($OekakiU)) {
	quiet_exit('Login could not be verified!  Take a screenshot of your picture.');
}
if (empty ($HTTP_RAW_POST_DATA)) {
	// No data to save!
	error_log (__FILE__.": No picture data to save.  User: $OekakiU");
	quiet_exit("No image data was recieved by the server.\nPlease try again, or take a screenshot of your picture.");
}


include('paintsave.php');


// Verify edit, otherwise invalidate it
$resno = verify_edit($edit);
if ($resno != 0) {
	$got_picid = 1;
} else {
	$got_picid = 0;
}


// Collect POST
$start  = strpos ($HTTP_RAW_POST_DATA, 'Content-type:');
$middle = 0;
$end    = 0;

while ($start) {
	// Foreach Content-type, get type
	$end    = strpos ($HTTP_RAW_POST_DATA, 'Content-type:', $start + 1);
	$middle = strpos ($HTTP_RAW_POST_DATA, "\r", $start);
	$type   = substr ($HTTP_RAW_POST_DATA, $start + 13, $middle - $start - 13 );
	$middle = strpos ($HTTP_RAW_POST_DATA, "\r", $middle + 1);

	if ($end === FALSE) {
		$end = NULL;
		$data = substr ($HTTP_RAW_POST_DATA, $middle + 2);
	} else {
		$data = substr ($HTTP_RAW_POST_DATA, $middle + 2, $end-$middle - 2);
	}

	$start = $end;

	// 'image/0'=PNG, 'image/1'=JPEG
	if ($type == 'image/0' || $type == 'image/1') {
		$picturedata = $data;
	}
	if ($type == 'animation/') {
		$animdata = $data;
	}

	unset ($data);
}


// Secure a new pic number if needed
if ($got_picid == 0) {
	$resno = get_new_picnumber();
	if ($resno == 0) {
		error_log (__FILE__.": Cannot allocate new PIC_ID.  User: $OekakiU");
		quiet_exit("Unable to allocate a new picture slot!\nTake a screenshot of your picture and tell an admin.");
	}
	$got_picid = 1;
}


// Insert new slot into database
if ($mode == 'norm' || $mode == 'anim') {
	// Remove old slot
	$result = kill_picnumber($resno);

	$thetime = time() - $edittimes;

	// Insert new slot
	$tries = 5;
	while ($tries > 0) {
		$sqlres = "INSERT INTO {$OekakiPoteto_Prefix}oekakidta SET usrname='$OekakiU', postdate=NOW(), hostname='$hostname', PIC_ID='$resno', IP='$address', datatype=1, edittime='$thetime'";
		if ($mode == 'anim') {
			$sqlres .= ', animation=1';
		} else {
			$sqlres .= ', animation=0';
		}
		$result = mysql_query ($sqlres);


		if ($result) {
			$tries = 0;
		} else {
			$tries--;
			sleep (1);
		}
	}
	if (!$result) {
		error_log (__FILE__.": Cannot save image.  Look for temp image.  User: $OekakiU, Number: $resno");
		quiet_exit("Unable to save image.\nPlease try again, or take a screenshot of your picture.");
	}
}


// Update edited slot to database
if ($mode == 'edit') {
	$edittime2 = time() - $edittimes;
	$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET edittime=(edittime + $edittime2) WHERE PIC_ID='$resno'");
}


// Save image/anim data.  Filetype is automatic!
if (!save_image($picturedata, $resno)) {
	error_log (__FILE__.": Cannot save image.  Look for temp image.  User: $OekakiU, Number: $resno");
	quiet_exit("Unable to save image.\nPlease try again, or take a screenshot of your picture.");
}
if (!empty ($animdata)) {
	if (!save_anim($animdata, $resno, 'oeb')) {
		error_log (__FILE__.": Cannot save anim.  Look for temp image.  User: $OekakiU, Number: $resno, Extension: .oeb");
	}
}


@mysql_close ($dbconn);

?>